/**
 * StubHandler.
 *
 * @author    Gifford Cheung
 * @version    $Id: StubHandler.java,v 1.3 2001/09/22 00:13:54 gkcheung Exp $
 */  

package ostore.mac;
import java.util.*;
import java.io.*;
import java.math.*;
import java.net.*;
import ostore.util.*;
import ostore.dispatch.*;
import ostore.tapestry.*;
import ostore.network.*;
import mdw.sandStorm.api.*;

/**
 *  StubHandler. For testing purposes.
 *
 */
public class StubHandler extends MacHandler { 

    public static final boolean DEBUG = true;
    BufferedReader console = new BufferedReader(new InputStreamReader(System.in));
    
    
    public void handleEvent(QueueElementIF item)
        throws EventHandlerException {
    }

    public void handleEvents(QueueElementIF item[])
        throws EventHandlerException {

        for (int i = 0; i < item.length; i += 1)
            handleEvent(item[i]);
    }
    public String idString() { return "Stub Handler."; } 

	public SecureHash myGuid() { return new SHA1Hash(); }

    /**
         * Establish a connection between the sender and recipient of the
         * the message. 
         *
         * @return <code>true</code> iff we have successfully established
         * a MAC connection between the sender and recipient of the
         * message
         **/
        public void establish(SecureHash guid) {
        Carp.out("trying to establish to " + guid);
        return;
    }
                                                      

    /**
     * @return <code>true</code> iff this message is authentic, i.e.
     * verified by the internal MAC
     **/
    public boolean authenticate(MACedQS msg, SecureHash guid) 
        throws GuidNotEstablished {
        System.out.print("Is " + msg + " authentic? (t/f)");
        String x = null;
        try { x = console.readLine();
        } catch (IOException e) {
            System.err.println("error, defaulting true");
            return true;
        }
        if (x.equals("t") || x.equals("true")) return true;
        return false;
    }

    /**
     * Computes the MAC code for the this message according to the guid
     **/
    public void doMAC(MACedQS msg, SecureHash receiverguid) 
        throws GuidNotEstablished {
        Carp.out("doMac " + msg);
        System.out.print("Is " + receiverguid + " established yet? (t/f)");
        String x = null;
        try { x = console.readLine();
        } catch (IOException e) {
            System.err.println("error, defaulting true");
            return;
        }
        if (x.equals("t") || x.equals("true")) return;
        throw new GuidNotEstablished("aaaahahah");
        //return;
    }

    public void init(ConfigDataIF config) throws Exception {
    }
    
    public void destroy() throws Exception {
        //TODO
    }

    private SinkIF _this_sink;

}

                
        
