/**
 * NetworkMessage.
 *
 * @author     Sean C. Rhea
 * @version    $Id: IdentityMessage.java,v 1.3 2001/06/08 22:03:06 srhea Exp $
 */

package ostore.network;
import ostore.util.*;
import mdw.sandStorm.api.*;

public class IdentityMessage extends NetworkMessage {

    public NodeId node_id;

    public IdentityMessage (NodeId peer, boolean inbound, NodeId node_id) {
	super (peer, inbound);
	this.node_id = node_id;
    }

    public IdentityMessage (byte [] data, int [] offset) {
	super (data, offset);
	node_id = new NodeId (data, offset);
    }

    public void to_bytes (byte [] data, int [] offset) {
	super.to_bytes (data, offset);
	node_id.to_bytes (data, offset);
    }

    public int type_code () {
	return ostore.util.Types.NETWORK_IDENTITY_MESSAGE;
    }

    public String toString () {
	return "(IdentityMessage " + super.toString () + " " 
	    + node_id + ")";
    }
}


