/**
 * EventCountRequestMsg.java
 *
 * Copyright (c) 2001 Regents of the University of California.
 * All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *  3. Neither the name of the University nor the names of its contributors
 *     may be used to endorse or promote products derived from this software
 *     without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 *  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 *  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 *  ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 *  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 *  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 *  OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 *  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 *  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 *  OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 *  SUCH DAMAGE.
 */

package ostore.oil;

import java.lang.reflect.Field;
import ostore.util.QSIO;
import ostore.util.InvalidConfigFileException;
import ostore.util.Carp;
import ostore.util.Debug;
import ostore.util.DebugFlags;
import ostore.dispatch.Classifier;
import ostore.dispatch.Filter;
import mdw.sandStorm.api.ConfigDataIF;
import mdw.sandStorm.api.UnknownEventException;
import mdw.sandStorm.api.EventHandlerIF;
import mdw.sandStorm.api.EventHandlerException;
import mdw.sandStorm.api.QueueElementIF;
import mdw.sandStorm.api.SinkIF;

/**
 *  EventCountRequestMsg is an event requesting to know how many times
 *  a certain event has been counted by EventCountStage.  An
 *  EventCountMsg will be sent back if there is a matching EventCountStage.
 *
 * @author	Jeremy Stribling
 * @version	$Id: EventCountRequestMsg.java,v 1.3 2001/11/28 23:03:15 geels Exp $
 *
 */
public class EventCountRequestMsg implements QueueElementIF
{
    ////////////////////       CONSTANTS	////////////////////
    private static final String class_tag = "EventCountRequestMsg"; 

    public String messageClassName;

    ////////////////////  STATIC CONSTRUCTORS	////////////////////
    ////////////////////      CONSTRUCTORS	////////////////////

    public EventCountRequestMsg( String className ) {

	messageClassName = className;

    }

    ////////////////////     STATIC METHODS 	////////////////////
    //////////////////// 	METHODS		////////////////////
    ////////////////////     INNER CLASSES	////////////////////

}

