/**
 * QSPrivateKey.
 *
 * @author     Sean C. Rhea
 * @version    $Id: QSPrivateKey.java,v 1.2 2002/03/29 23:26:21 eaton Exp $
 */

package ostore.security;
import ostore.util.*;
import java.security.*;

/**
 * An interface to wrap objects of type {@link java.security.PrivateKey} in
 * a <code>QuickSerializable</code> interface.
 * 
 * @author   Sean C. Rhea
 * @version  $Id: QSPrivateKey.java,v 1.2 2002/03/29 23:26:21 eaton Exp $
 */
public interface QSPrivateKey extends Digestible {

    /**
     * Return the key associated with this object.
     * 
     * @return the key associated with this object
     */
    public PrivateKey key ();
}

