/**
 * QSPublicKey.
 *
 * @author     Sean C. Rhea
 * @version    $Id: QSPublicKey.java,v 1.2 2002/03/29 01:59:58 srhea Exp $
 */

package ostore.security;
import ostore.util.*;
import java.security.*;

/**
 * An interface to wrap objects of type {@link java.security.PublicKey} in
 * a <code>QuickSerializable</code> interface.
 * 
 * @author   Sean C. Rhea
 * @version  $Id: QSPublicKey.java,v 1.2 2002/03/29 01:59:58 srhea Exp $
 */
public interface QSPublicKey extends Digestible {

    /**
     * Return the key associated with this object.
     * 
     * @return the key associated with this object
     */
    public PublicKey key ();
}

