/**
 * QSSha1RsaSignature.
 *
 * @author     Sean C. Rhea
 * @version    $Id: QSSha1RsaSignature.java,v 1.4 2001/11/16 22:44:45 geels Exp $
 */

package ostore.security;
import ostore.util.*;
import java.security.*;

/**
 * A QSSignature subtype for RSA/SHA-1 signatures.
 * 
 * @author   Sean C. Rhea
 * @version  $Id: QSSha1RsaSignature.java,v 1.4 2001/11/16 22:44:45 geels Exp $
 *
 * @see SignedQS
 */
public class QSSha1RsaSignature implements QSSignature {

    /**
     * The default constructor.
     */
    public QSSha1RsaSignature () {}

    /**
     * The deserialization constructor.  See the comments at the top of
     * {@link ostore.util.QuickSerializable} for details.
     */
    public QSSha1RsaSignature (byte [] data, int [] offset) {}

    public String algorithm () { return "SHA-1/RSA/PKCS#1"; }
    public String provider () { return "CryptixCrypto"; }

    public void to_bytes (byte [] data, int [] offset) {}

    public int type_code () {
	return Types.SECURITY_QS_SHA1_RSA_SIGNATURE;
    }

    public int hashCode() {
	return type_code();
    }

    public boolean equals( Object obj ) {
	return ( obj instanceof QSSha1RsaSignature );
    }
    
    public String toString () { return "QSSha1RsaSignature"; }
}

