/**
 * Tapestry internal message for advertising the location of an object
 * To do -- <br>
 * Debugging/testing
 *
 * @author     Scott Honey
 * @version    $Id
 */





package ostore.tapestry;

import java.util.*;
import java.net.*;
import ostore.util.*;
import ostore.dispatch.*;
import ostore.network.*;
import mdw.sandStorm.api.*;  //probably not needed.
import mdw.sandStorm.lib.aSocket.*; //probably not needed.



public class AdvertiseMessage extends TapestryInternalMessage {
    
    public SHA1Hash guid;
    
    
    
	//TODO make an entry in Types.java for this.

	/* 
	   //register in type table  obsolete --
   static {
	try {
	    TypeTable.register_type ("ostore.tapestry.AdvertiseMessage",Types.);
	}
	catch (TypeTable.DuplicateTypeCode e) {
	    //Carp.die ("AdvertiseMessage has a duplicate code");
	}
    }*/
    

    
    /** null constructor*/
    public AdvertiseMessage(){
	
    }

    /**Typical constructor*/
    public AdvertiseMessage(SHA1Hash source, SHA1Hash destination, NodeId nextHop, int hop, SHA1Hash t_guid){
        
	super(ostore.util.Types.TAPESTRY_ADVERTISE_MESSAGE,source,destination,nextHop,hop);
	guid = t_guid;
    }
    
    
    /** Packs in the query on top of the TapestryInternalMessage format

	guid
    */
    
    public int to_bytes( byte[] data, int offset){
	int old_offset = offset;
	offset += super.to_bytes (data, offset); //lots done by TapestryInternalMessage
	
	offset +=guid.to_bytes(data, offset);
	return offset - old_offset;
    }
    


    /** unpacks the query on top of the TapestryInternalMessage format

	guid
    */

    public int from_bytes (byte [] data, int offset) {
	int old_offset = offset;
	offset += super.from_bytes (data, offset);//lots done by TapestryInternalMessage
	
	if (guid == null){
	    guid = new SHA1Hash ();
	}
	offset += guid.from_bytes (data, offset);
	
	return offset - old_offset;
    }   
    
    
    
    public String toString(){
		//	return (super.toString() + "AdvertiseMessage: " +guid+"\n");
		return ("AdvertiseMessage "+super.toString());
    }
    
}


