/**
 * Tapestry internal message/parent class for errors...
 * To do -- <br>
 * Debugging/testing
 *
 * @author     Scott Honey
 * @version    $Id
 */





package ostore.tapestry;

import java.util.*;
import java.net.*;
import ostore.util.*;
import ostore.dispatch.*;
import ostore.network.*;
import mdw.sandStorm.api.*;  //probably not needed.
import mdw.sandStorm.lib.aSocket.*; //probably not needed.



public class ErrorMessage extends TapestryInternalMessage {
    


    //as of yet, undefined
    public int errorCode;


	//TODO make an entry in Types.java for this.
	/*    
    //register in type table
    static {
	try {
	TypeTable.register_type (new ErrorMessage ());
	}
	catch (TypeTable.DuplicateTypeCode e) {
	//Carp.die ("ErrorMessage has duplicate type code.");
	}
    }*/
    
    
    /** null constructor*/
    public ErrorMessage(){
	
    }

    /**Typical constructor*/
    public ErrorMessage(SHA1Hash source, SHA1Hash destination, NodeId nextHop, int hop, int t_errorCode){
        
	super(ostore.util.Types.TAPESTRY_ERROR_MESSAGE,source,destination,nextHop,hop);
	errorCode = t_errorCode;
	
    }
    
    
    /** Packs in the unadvertise on top of the TapestryInternalMessage format

	errorCode
    */
    
    public int to_bytes( byte[] data, int offset){
	int old_offset = offset;
	offset += super.to_bytes (data, offset); //lots done by TapestryInternalMessage
	
   	offset +=ByteUtils.intToBytes (errorCode, data, offset);
	return offset - old_offset;
    }
    
	

    /** unpacks the unadvertise on top of the TapestryInternalMessage format
	
	errorCode

    */

    public int from_bytes (byte [] data, int offset) {
	int old_offset = offset;
	offset += super.from_bytes (data, offset);//lots done by TapestryInternalMessage
	

	errorCode = ByteUtils.bytesToInt (data, offset);
	offset += 4;
	
	return offset - old_offset;
    }   
    
    
    
    public String toString(){
	return (super.toString() + " ErrorMessage: code= " +errorCode+"\n");
    }
    
}


