/**
 * ObjectNotFoundTError
 *
 * @author     Ben Y. Zhao
 * @version    $Id: ObjectNotFoundTError.java,v 1.1 2001/06/07 23:54:33 ravenben Exp $
 */

package ostore.tapestry;
import ostore.util.*;
import mdw.sandStorm.api.*;

/** used when searching/routing message to object does not find
 ** the object, or not enough copies of the object as requested.
 **/
public class ObjectNotFoundTError extends TErrorEvent {

  public ObjectNotFoundTError(SecureHash location, boolean usingMAC,
			      boolean verifiedMAC, String errorMessage) {
    super(location, usingMAC, verifiedMAC, errorMessage);
  }

  public String toString() {
    return "(ObjectNotFoundTError at: "+errorLocation+" " + errorMessage + ")";
  }

  /*
  public int type_code () {
    return ostore.util.Types.STARTREK_OBJECTNOTFOUNDTERROR;
  }
  static {
    try {
      TypeTable.register_type (new ObjectNotFoundTError());
    }
    catch (TypeTable.DuplicateTypeCode e) {
      Carp.die ("ObjectNotFoundTError has duplicate type code.");
    }
    }*/
}
