/** This object keeps track of all of the information about a
node-object pairings, etc.

TODO : debug -- this has not been debugged, but ManyTable has been looked at.

@version 1.0
@author Scott Honey s_honey@uclink.berkeley.edu
*/

package ostore.tapestry;

import java.util.*;
import ostore.util.*;

public class ObjectTable {
    
    
    
    private ManyTable m_nodeToObject;
    private ManyTable m_objectToNode;
    
    
    public ObjectTable() {
	m_nodeToObject = new ManyTable();
	m_objectToNode = new ManyTable();
    }
    


    public void addObj(SHA1Hash node, SHA1Hash obj){
	m_nodeToObject.addObject(node,obj);
	m_objectToNode.addObject(obj,node);
    }
    

    /*I think this one is useless.  
       public void addNode(SHA1Hash node){
       m_objectToNode(node,node);
       
       }*/
    
    
    
    public void removeObj(SHA1Hash node, SHA1Hash obj){
	m_objectToNode.removeObject(obj,node);
	m_nodeToObject.removeObject(node,obj);
	
    }


    public void removeObj(SHA1Hash obj){
	Enumeration e = m_objectToNode.getObjects(obj);
	
	while (e.hasMoreElements()){
	    m_nodeToObject.removeObject((SHA1Hash) e.nextElement(), obj);
	}
	m_objectToNode.removeKey(obj);
    }


    public void removeNode(SHA1Hash node){
	Enumeration e = m_nodeToObject.getObjects(node);
	
	while (e.hasMoreElements()){
	    m_objectToNode.removeObject((SHA1Hash) e.nextElement(), node);
	}
	m_nodeToObject.removeKey(node);
    }


    /**@return the number of nodes that link to obj
     */
    public int countNodes(SHA1Hash obj){
	return m_objectToNode.getNumObjects(obj);
    }


    /**@return the number of objects that a node has
     */
    public int countObj(SHA1Hash node){
	return m_nodeToObject.getNumObjects(node);
    }
    
    
    
    /**returns all of them*/
    public Enumeration getNode(SHA1Hash obj){
	return m_nodeToObject.getObjects(obj);
    }
    
    
    public Enumeration getNode(SHA1Hash obj, int select, int from){
	if ((countNodes(obj)<from)  ||
	    (select>from))  {
	    return null;
	}
	
	Vector v = new Vector();
	Enumeration e = m_objectToNode.getObjects(obj);
	
	for (int i = 0; i < select; i++){
	    v.addElement(e.nextElement());
	}
	
	return v.elements();
    }

    
    
    public static void main (String[] args){
	
	
	
    }

    
}


