/**
 * RouteParentTMessage
 *
 * @author     Ben Y. Zhao
 * @version    $Id: RouteParentTMessage.java,v 1.2 2001/06/08 22:21:05 srhea Exp $
 */

package ostore.tapestry;
import ostore.util.*;
import mdw.sandStorm.api.*;

/**************
 * Event to request Tapestry routing to find a dissemination tree
 * parent.  The semantics is that we try to find an exact match to
 * a server containing the ObjGuid, and it cannot be the current node.
 */
public abstract class RouteParentTMessage extends TMessageEvent {
    public SecureHash objGuid;

    public RouteParentTMessage(SecureHash oGuid) {
	super(oGuid, 
		false, /* false, not inbound */
		true, /* using MAC by default */
		false); /* verified N/A */
	objGuid = oGuid;
    }

    public RouteParentTMessage (byte [] data, int [] offset) {
	super (data, offset);
    }

    public String toString() {
	return "(RouteParentTMessage "+super.toString()+")";
    }
}

