/**
 * Tapestry internal message for search messages<br>
 * To do -- <br>
 * Debugging/testing
 *
 * @author     Scott Honey
 * @version    $Id
 */





package ostore.tapestry;

import java.util.*;
import java.net.*;
import ostore.util.*;
import ostore.dispatch.*;
import ostore.network.*;
import mdw.sandStorm.api.*;  //probably not needed.
import mdw.sandStorm.lib.aSocket.*; //probably not needed.



public class RouteSearchMessage extends TapestryInternalMessage {
    
    /** When the message reaches a node that can select x from y, it
        forwards this message with the finalHop boolean set to each of
        the selected nodes.*/
    public int select;
    public int from;
    
    
    /** indicates that the node that this message is sent to is
        expected to have the object requested, and that it should send
        an error if it doesn't.  If a node receives this, then it
        should forget about from/select, and just notify the dispatch
        that the source requested the guid.*/
    public boolean finalHop;
    
    

	//TODO make an entry in Types.java for this.
	/*
    //register in type table
    static {
	try {
	    TypeTable.register_type (new RouteSearchMessage ());
	}
	catch (TypeTable.DuplicateTypeCode e) {
	    //Carp.die ("RouteSearchMessage has duplicate type code.");
	}
    }*/
    
    
    /** null constructor*/
    public RouteSearchMessage(){
	
    }

    /**Typical constructor*/
    public RouteSearchMessage(int typeCode, SHA1Hash source, SHA1Hash destination, NodeId nextHop, int hop, int t_select, int t_from, boolean t_finalHop){
        
	super(ostore.util.Types.TAPESTRY_ROUTE_SEARCH_MESSAGE,source,destination,nextHop,hop);
	select = t_select;
	from = t_from;
	finalHop = t_finalHop;
    }
    
    
    /** Packs in the query on top of the TapestryInternalMessage format

	select
	from
	finalhop
    */
    
    public int to_bytes( byte[] data, int offset){
	int old_offset = offset;
	offset += super.to_bytes (data, offset); //lots done by TapestryInternalMessage
	
	offset += ByteUtils.intToBytes (select, data, offset);
	offset += ByteUtils.intToBytes (from, data, offset);
	offset +=ByteUtils.boolToBytes (finalHop, data, offset);
	
	return offset - old_offset;
    }
    


    /** unpacks the query on to of the TapestryInternalMessage format

	select
	from
	finalhop
    */

    public int from_bytes (byte [] data, int offset) {
	int old_offset = offset;
	offset += super.from_bytes (data, offset);//lots done by TapestryInternalMessage
	
	select =  ByteUtils.bytesToInt (data, offset);
	offset += 4;

	from =  ByteUtils.bytesToInt (data, offset);
	offset += 4;
	
	finalHop =  ByteUtils.bytesToBool (data, offset);
	offset += ByteUtils.SIZE_BOOL;
	
	return offset - old_offset;
    }   
    
    
    
    public String toString(){
	return (super.toString() + " RouteSearchMessage: Select:From=  " +
		select + ":"+from+"\n");
		
    }
    
}
