/**
 * TErrorEvent
 *
 * @author     Ben Y. Zhao
 * @version    $Id: TErrorEvent.java,v 1.3 2001/06/08 23:50:50 srhea Exp $
 */

package ostore.tapestry;
import ostore.util.*;
import mdw.sandStorm.api.*;

/****************
 ** Superclass for all Tapestry Error events
 ** This is assumed to always be an incoming event, since it's the 
 ** event sent to the dispatcher from the Tapestry stage.
 **/
public class TErrorEvent implements TEventIF {

  /**
   * Guid of the node where the error occured
   */
  public SecureHash errorLocation;
  /**
   * whether end to end MAC is enabled
   */
  public boolean usingMAC;
  /**
   * whether the MAC is verified
   */
  public boolean verifiedMAC;

  public String errorMessage;

  public TErrorEvent(SecureHash location, boolean using,
		     boolean verified, String message) {
    errorLocation = location;
    usingMAC = using;
    verifiedMAC = verified;
    errorMessage = message;
  }

  public String toString() {
    return "(TErrorEvent at: "+errorLocation+" " + errorMessage + ")";
  }
}
