/**
 * TapestryRouteMsg.
 *
 * @author     Sean C. Rhea
 * @version    $Id: TapestryInstance.java,v 1.3 2001/12/02 04:08:05 srhea Exp $
 */
package ostore.tapestry.api;
import java.util.Map;
import java.util.HashMap;
import ostore.util.Assert;
import ostore.util.NodeId;
import ostore.util.SecureHash;

public class TapestryInstance {

    public SecureHash self_guid () { 
	Assert.assert (_self_guid != null, 
		"TapestryInstance.self_guid: self guid not yet set.");
	return _self_guid;
    }
    
    public void set_self_guid (SecureHash g) {
	Assert.assert (_self_guid == null,
		"TapestryInstance.set_self_guid: self guid already set.");
	_self_guid = g;
    }

    public static TapestryInstance instance (NodeId node_id) {
	synchronized (_instances) {
	    if (! _instances.containsKey (node_id)) {
		_instances.put (node_id, new TapestryInstance ());
	    }
	    return (TapestryInstance) _instances.get (node_id);
	}
    }

    private static Map _instances;
    static {
	_instances = new HashMap ();
    }

    private SecureHash _self_guid;
}

