/**
 * DynamicNotifyMsg.java
 *
 * @author Ben Y. Zhao
 * @version $Id: DynamicNotifyMsg.java,v 1.1 2001/10/02 23:21:27 ravenben Exp $
 */

package ostore.tapestry.impl;
import ostore.network.NetworkMessage;
import ostore.util.Types;
import ostore.util.NodeId;
import ostore.util.SecureHash;
import ostore.util.TypeTable;
import ostore.util.ByteUtils;
import ostore.util.QSException;
// import ostore.mac.MACedQS;

public class DynamicNotifyMsg extends NetworkMessage {

  public SecureHash src;
  public SecureHash dest;

  public DynamicNotifyMsg (NodeId peer, SecureHash src, SecureHash dest) {
    super (peer, false /*outbound*/);
    this.src = src;
    this.dest = dest;
  }

  public DynamicNotifyMsg (byte [] data, int [] offset) throws QSException {
    super (data, offset);
    int type = ByteUtils.bytesToInt(data, offset);
    src = (SecureHash) TypeTable.new_object(type, data, offset);
    type = ByteUtils.bytesToInt(data, offset);
    dest = (SecureHash) TypeTable.new_object(type, data, offset);
  }

  /*  public QuickSerializable data_to_mac() {
    QuickSerializable [] x = {src, dest, user_data};
    return new QSArray(x);
    } */

  public void to_bytes(byte [] data, int [] offset) {
    super.to_bytes(data, offset);
    ByteUtils.intToBytes(src.type_code(), data, offset);
    src.to_bytes(data, offset);
    ByteUtils.intToBytes(dest.type_code(), data, offset);
    dest.to_bytes(data, offset);
    /*    ByteUtils.intToBytes(user_data.type_code(), data, offset);
	  user_data.to_bytes(data, offset);
	  if (mac == null)
	  ByteUtils.intToBytes(0, data, offset);
	  else {
	  ByteUtils.intToBytes(mac.type_code(), data, offset);
	  mac.to_bytes(data, offset);
	  } */
  }

  public int type_code() {
    return Types.TAPESTRY_DYNAMIC_NOT_MSG;
  }

  public Object clone () throws CloneNotSupportedException {
    DynamicNotifyMsg result = (DynamicNotifyMsg) super.clone();
    result.src = src;
    result.dest = dest;
    return result;
  }

  public String toString() {
    return "(DynamicNotifyMsg)";
  }

}
