/**
 * DynamicSurrReqMsg.java
 *
 * @author Ben Y. Zhao
 * @version $Id: DynamicSurrReqMsg.java,v 1.1 2001/10/09 03:33:11 ravenben Exp $
 */

package ostore.tapestry.impl;
import ostore.network.NetworkMessage;
import ostore.util.Types;
import ostore.util.NodeId;
import ostore.util.SecureHash;
import ostore.util.TypeTable;
import ostore.util.ByteUtils;
import ostore.util.QSException;

public class DynamicSurrReqMsg extends NetworkMessage {

  public SecureHash src;
  public int hop;

  public DynamicSurrReqMsg (NodeId peer, SecureHash src, int hop) {
    super (peer, false /*outbound*/);
    this.src = src;
    this.hop = hop;
  }

  public DynamicSurrReqMsg (byte [] data, int [] offset) throws QSException {
    super (data, offset);
    int type = ByteUtils.bytesToInt(data, offset);
    src = (SecureHash) TypeTable.new_object(type, data, offset);
    hop = ByteUtils.bytesToInt(data, offset);
  }

  public void to_bytes(byte [] data, int [] offset) {
    super.to_bytes(data, offset);
    ByteUtils.intToBytes(src.type_code(), data, offset);
    src.to_bytes(data, offset);
    ByteUtils.intToBytes(hop, data, offset);
  }

  public int type_code() {
    return Types.TAPESTRY_DYNAMIC_SURRREQ_MSG;
  }

  public Object clone () throws CloneNotSupportedException {
    DynamicSurrReqMsg result = (DynamicSurrReqMsg) super.clone();
    result.src = src;
    result.hop = hop;
    return result;
  }

  public String toString() {
    return "(DynamicSurrReqMsg: hop="+hop+")";
  }

}
