/**
 * StaticAliveMsg.
 *
 * @author     Sean C. Rhea
 * @version    $Id: StaticAliveMsg.java,v 1.1 2001/09/11 02:40:55 srhea Exp $
 */

package ostore.tapestry.impl;
import ostore.network.NetworkMessage;
import ostore.util.Types;
import ostore.util.NodeId;
import ostore.util.SecureHash;
import ostore.util.TypeTable;
import ostore.util.ByteUtils;
import ostore.util.QSException;

public class StaticAliveMsg extends NetworkMessage {

    public SecureHash guid;

    public StaticAliveMsg (NodeId peer, SecureHash guid) {
	super (peer, false /* outbound */);
	this.guid = guid;
    }

    public StaticAliveMsg (byte [] data, int [] offset) throws QSException {
	super (data, offset);
	int typecode = ByteUtils.bytesToInt (data, offset);
	guid = (SecureHash) TypeTable.new_object (typecode, data, offset);
    }

    public void to_bytes (byte [] data, int [] offset) {
	super.to_bytes (data, offset);
	ByteUtils.intToBytes (guid.type_code (), data, offset);
	guid.to_bytes (data, offset);
    }

    public int type_code () {
	return Types.TAPESTRY_STATIC_ALIVE_MSG;
    }

    public Object clone () throws CloneNotSupportedException {
	return super.clone ();
    }

    public String toString () {
	return "(StaticAliveMsg " + super.toString () + ")";
    }
}

