/**
 * TestFoundMsg.java
 *
 * @author     Ben Y. Zhao
 * @version    $Id: TestFoundMsg.java,v 1.4 2002/04/06 22:52:44 eaton Exp $
 */

package ostore.tapestry.impl;
import ostore.util.QSException;
import ostore.util.Types;
import ostore.util.SecureHash;
import ostore.util.SecureHashBuffer;
import ostore.util.ByteUtils;
import ostore.util.TypeTable;
import ostore.tapestry.api.TapestryRouteMsg;

/**
 * The msg to say we found the object you're looking for
 */
public class TestFoundMsg extends TapestryRouteMsg {

  public SecureHash objGuid;

  public TestFoundMsg (SecureHash dest_guid, SecureHash oguid) {
    super (dest_guid);
    this.objGuid = oguid;
  }

  public TestFoundMsg (byte[] data, int[] offset)
    throws QSException {
      long type = ByteUtils.bytesToLong(data, offset);
    objGuid = (SecureHash) TypeTable.new_object(type, data, offset);
  }
  
  public void to_bytes(byte[] data, int[] offset) {
      ByteUtils.longToBytes(TypeTable.type_code(objGuid), data, offset);
    objGuid.to_bytes(data, offset);
  }
  
  public int type_code () {
      throw new NoSuchMethodError();
      //return Types.TAPESTRY_TEST_FOUND_MSG;
  }

    public void add_to_digest(SecureHashBuffer buffer)
    {
        buffer.add(TypeTable.type_code(objGuid));
        buffer.add(objGuid);
    }

  public String toString() {
    return "(TestFoundMsg for object "+objGuid+", "+super.toString()+")";
  }
}


