#!/usr/bin/perl -w
#
# $Id: add-network-top.pl,v 1.1 2002/02/19 20:29:00 srhea Exp $
#
# Adds the topology information given on the command line to the network
# stage of a .cfg file.
#
# usage:  add-network-top.pl <topology graph> <topology mapping>
#
# (Input .cfg is from STDIN; output .cfg is on STDOUT.)
#
# See the new test-ostore.inner for an example usage.
#
use strict;

my $graph = $ARGV[0];
my $mapping = $ARGV[1];

my $network = 0;
while (<STDIN>) {

    if ($network == 0) {

	# find the network stage
	if (m/<Network>/) {
	    $network = 1;
	}
	print;
    }
    else {
	
	print;
	if (m/<initargs>/) {
	    print "topology_graph $graph\n";
	    print "topology_mapping $mapping\n";
	    $network = 0;
	}
    }
}

